﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2005/xpath-functions"
                xmlns:cce="http://www.sat.gob.mx/ComercioExterior">

    <xsl:template match="cce:ComercioExterior">
        <!--Manejador de nodos tipo ComercioExterior-->
        <xsl:call-template name="Requerido">
            <xsl:with-param name="valor" select="./@Version"/>
        </xsl:call-template>
        <xsl:call-template name="Requerido">
            <xsl:with-param name="valor" select="./@TipoOperacion"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@ClaveDePedimento"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@CertificadoOrigen"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@NumCertificadoOrigen"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@NumeroExportadorConfiable"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Incoterm"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Subdivision"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Observaciones"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@TipoCambioUSD"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@TotalUSD"/>
        </xsl:call-template>

        <!--  Iniciamos el manejo de los elementos hijo en la secuencia -->
        <xsl:apply-templates select="./cce:Emisor"/>
        <xsl:apply-templates select="./cce:Receptor"/>
        <xsl:apply-templates select="./cce:Destinatario"/>
        <xsl:apply-templates select="./cce:Mercancias"/>
    </xsl:template>


    <xsl:template match="cce:Emisor">
        <!--  Iniciamos el tratamiento de los atributos de cce:Emisor-->
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Curp"/>
        </xsl:call-template>
    </xsl:template>


    <xsl:template match="cce:Receptor">
        <!--  Tratamiento de los atributos de cce:Receptor-->
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Curp"/>
        </xsl:call-template>
        <xsl:call-template name="Requerido">
            <xsl:with-param name="valor" select="./@NumRegIdTrib"/>
        </xsl:call-template>
    </xsl:template>


    <xsl:template match="cce:Destinatario">
        <!--  Tratamiento de los atributos de cce:Destinatario-->
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@NumRegIdTrib"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Rfc"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Curp"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Nombre"/>
        </xsl:call-template>
        <!--  Manejo de los nodos dependientes -->
        <xsl:apply-templates select="./cce:Domicilio"/>
    </xsl:template>


    <xsl:template match="cce:Mercancias">
        <!--  Iniciamos el manejo de los nodos dependientes -->
        <xsl:for-each select="./cce:Mercancia">
            <xsl:apply-templates select="."/>
        </xsl:for-each>
    </xsl:template>


    <xsl:template match="cce:Domicilio">
        <!--  Iniciamos el tratamiento de los atributos de cce:Domicilio-->
        <xsl:call-template name="Requerido">
            <xsl:with-param name="valor" select="./@Calle"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@NumeroExterior"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@NumeroInterior"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Colonia"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Localidad"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Referencia"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Municipio"/>
        </xsl:call-template>
        <xsl:call-template name="Requerido">
            <xsl:with-param name="valor" select="./@Estado"/>
        </xsl:call-template>
        <xsl:call-template name="Requerido">
            <xsl:with-param name="valor" select="./@Pais"/>
        </xsl:call-template>
        <xsl:call-template name="Requerido">
            <xsl:with-param name="valor" select="./@CodigoPostal"/>
        </xsl:call-template>
    </xsl:template>


    <xsl:template match="cce:Mercancia">
        <xsl:call-template name="Requerido">
            <xsl:with-param name="valor" select="./@NoIdentificacion"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@FraccionArancelaria"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@CantidadAduana"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@UnidadAduana"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@ValorUnitarioAduana"/>
        </xsl:call-template>
        <xsl:call-template name="Requerido">
            <xsl:with-param name="valor" select="./@ValorDolares"/>
        </xsl:call-template>

        <!--  Manejo de los nodos dependientes -->
        <xsl:for-each select="./cce:DescripcionesEspecificas">
            <xsl:apply-templates select="."/>
        </xsl:for-each>

    </xsl:template>


    <xsl:template match="cce:DescripcionesEspecificas">
        <!--  Iniciamos el tratamiento de los atributos de cce:descripcionesEspecificas-->
        <xsl:call-template name="Requerido">
            <xsl:with-param name="valor" select="./@Marca"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@Modelo"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@SubModelo"/>
        </xsl:call-template>
        <xsl:call-template name="Opcional">
            <xsl:with-param name="valor" select="./@NumeroSerie"/>
        </xsl:call-template>
    </xsl:template>


</xsl:stylesheet>